diff --git a/gdb/ChangeLog b/gdb/ChangeLog
index f795526..fd2700d 100644
--- a/gdb/ChangeLog
+++ b/gdb/ChangeLog
@@ -1,3 +1,8 @@
+2017-12-18  Xavier Roirand  <roirand@adacore.com>
+
+	* ada-lang.c (ada_convert_actual): Change the way actual value
+	are passed to the inferior when the inferior expects a pointer type.
+
 2017-12-17  Stafford Horne  <shorne@gmail.com>
 
 	* gdb/or1k-tdep.c (show_or1k_debug): Fix function parameter alignment.
diff --git a/gdb/ada-lang.c b/gdb/ada-lang.c
index c40803c..8a0423e 100644
--- a/gdb/ada-lang.c
+++ b/gdb/ada-lang.c
@@ -4513,7 +4513,7 @@ ada_convert_actual (struct value *actual, struct type *formal_type0)
       if (TYPE_CODE (formal_target) == TYPE_CODE_ARRAY
           && ada_is_array_descriptor_type (actual_target))
 	result = desc_data (actual);
-      else if (TYPE_CODE (actual_type) != TYPE_CODE_PTR)
+      else if (TYPE_CODE (formal_type) != TYPE_CODE_PTR)
         {
           if (VALUE_LVAL (actual) != lval_memory)
             {
diff --git a/gdb/testsuite/ChangeLog b/gdb/testsuite/ChangeLog
index 99fa805..3075686 100644
--- a/gdb/testsuite/ChangeLog
+++ b/gdb/testsuite/ChangeLog
@@ -1,3 +1,7 @@
+2017-12-18  Xavier Roirand  <roirand@adacore.com>
+
+	* gdb.ada/funcall_ptr: New testcase.
+
 2017-12-15  Sergio Durigan Junior  <sergiodj@redhat.com>
 
 	PR cli/16224
diff --git a/gdb/testsuite/gdb.ada/funcall_ptr.exp b/gdb/testsuite/gdb.ada/funcall_ptr.exp
new file mode 100644
index 0000000..e9904a4
--- /dev/null
+++ b/gdb/testsuite/gdb.ada/funcall_ptr.exp
@@ -0,0 +1,40 @@
+# Copyright 2017 Free Software Foundation, Inc.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+load_lib "ada.exp"
+
+standard_ada_testfile foo
+
+if {[gdb_compile_ada "$srcfile" "$binfile" executable [list debug]] != "" } {
+  return -1
+}
+
+clean_restart ${testfile}
+
+set bp_location [gdb_get_line_number "BREAK" ${testdir}/foo.adb]
+runto "foo.adb:$bp_location"
+
+gdb_test "print pck.ga" " = \\(access integer\\) 0x0" \
+         "Check that initial value of GA is null"
+
+gdb_test_no_output "call pck.p(0x1234)"
+
+# Check that argument 'A' was passed correctly in the call to Pck.P
+# above. We check that, by printing GA global variable.
+# The GA global variable is set with the value of parameter 'A' inside p
+# procedure hence should be 0x1234 after the call above.
+
+gdb_test "print pck.ga" " = \\(access integer\\) 0x1234" \
+         "Check that value of GA is 0x1234"
diff --git a/gdb/testsuite/gdb.ada/funcall_ptr/foo.adb b/gdb/testsuite/gdb.ada/funcall_ptr/foo.adb
new file mode 100644
index 0000000..25a5aef
--- /dev/null
+++ b/gdb/testsuite/gdb.ada/funcall_ptr/foo.adb
@@ -0,0 +1,21 @@
+--  Copyright 2017 Free Software Foundation, Inc.
+--
+--  This program is free software; you can redistribute it and/or modify
+--  it under the terms of the GNU General Public License as published by
+--  the Free Software Foundation; either version 3 of the License, or
+--  (at your option) any later version.
+--
+--  This program is distributed in the hope that it will be useful,
+--  but WITHOUT ANY WARRANTY; without even the implied warranty of
+--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+--  GNU General Public License for more details.
+--
+--  You should have received a copy of the GNU General Public License
+--  along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+with Pck; use Pck;
+
+procedure Foo is
+begin
+   P (null); -- BREAK
+end Foo;
diff --git a/gdb/testsuite/gdb.ada/funcall_ptr/pck.adb b/gdb/testsuite/gdb.ada/funcall_ptr/pck.adb
new file mode 100644
index 0000000..faf91bf
--- /dev/null
+++ b/gdb/testsuite/gdb.ada/funcall_ptr/pck.adb
@@ -0,0 +1,23 @@
+--  Copyright 2017 Free Software Foundation, Inc.
+--
+--  This program is free software; you can redistribute it and/or modify
+--  it under the terms of the GNU General Public License as published by
+--  the Free Software Foundation; either version 3 of the License, or
+--  (at your option) any later version.
+--
+--  This program is distributed in the hope that it will be useful,
+--  but WITHOUT ANY WARRANTY; without even the implied warranty of
+--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+--  GNU General Public License for more details.
+--
+--  You should have received a copy of the GNU General Public License
+--  along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+package body Pck is
+
+   procedure P (A : Integer_Access) is
+   begin
+      GA := A;
+   end P;
+
+end Pck;
diff --git a/gdb/testsuite/gdb.ada/funcall_ptr/pck.ads b/gdb/testsuite/gdb.ada/funcall_ptr/pck.ads
new file mode 100644
index 0000000..9595b71
--- /dev/null
+++ b/gdb/testsuite/gdb.ada/funcall_ptr/pck.ads
@@ -0,0 +1,24 @@
+--  Copyright 2017 Free Software Foundation, Inc.
+--
+--  This program is free software; you can redistribute it and/or modify
+--  it under the terms of the GNU General Public License as published by
+--  the Free Software Foundation; either version 3 of the License, or
+--  (at your option) any later version.
+--
+--  This program is distributed in the hope that it will be useful,
+--  but WITHOUT ANY WARRANTY; without even the implied warranty of
+--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+--  GNU General Public License for more details.
+--
+--  You should have received a copy of the GNU General Public License
+--  along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+package Pck is
+
+   type Integer_Access is access all Integer;
+
+   procedure P (A : Integer_Access);
+
+   GA : Integer_Access;
+
+end Pck;